OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH("h8300hn")

MEMORY
{
        VECTORS(r):             ORIGIN = 0x0000, LENGTH = 0x0100
        ROM(rx):                ORIGIN = 0x0100, LENGTH = 0x7f00
        RAM(rwx):               ORIGIN = 0xfd80, LENGTH = 0x0110
        STACK(rw):              ORIGIN = 0xfe90, LENGTH = 0x0100
}

SECTIONS
{
.vectors : {
	  *(.vectors)
  } > VECTORS

.text 0x0100 :
  {
    __text = .; 
    *(.text)
    *(.rodata)
    *(.rodata.str*)
  } > ROM
  . = ALIGN(4);
  
  __idata_start = .; 
.data : AT(__idata_start)
  {
    __data_start = .; 
    *(.data)
  } > RAM
  . = ALIGN(2);	
  __idata_end = __idata_start + SIZEOF(.data);
    
  __bss_start = .;
.bss :
  {
    *(.bss)
    *(COMMON)
  } > RAM
  . = ALIGN(2);
  __bss_end = .;

  __stack_start = .;
.stack   :
  {
    *(.stack)
  } > STACK
  __stack_end = .;
}
