#include "H8-3694F.h"

#define INTERVAL		4000

#define SCI_TDRE		0x80
#define SCI_RDRF		0x40
#define SCI_OER			0x20
#define SCI_FER			0x10
#define SCI_PER			0x08
#define SCI_TEND		0x04

#define SCI_RDRF_CLEAR		0xBC
#define SCI_TDRE_CLEAR		0x78
#define SCI_ERROR_CLEAR		0xC4

#define	CPU_FREQUENCY		20000000	// ãУեåȿ.

void
init_serial(void)
{
  int i = INTERVAL;

  PMR1 = 0x0e;
  SCR3 = 0x00;		/* TE/RE CLEAR */  
  SMR  = 0x00;		/* ASYNC 8 BIT, NON PARITY, 1 STOP BIT */
//  BRR  = 0x0f;		/* 38400 BPS */
  BRR  = 0x20;	/* 19200 BPS */
//  BRR  = 0x40;	/*  9600 BPS */
  while (i--);		/* WAIT 1 BIT CYCLE */
  SCR3 = 0x70;		/* RIE/TE/RE SET */
  i = SSR;
  SSR  = 0x80;
}

/*********************************************************************
 *	ӣãɡܡ졼.
 *********************************************************************
 */
void sci_setBaud(int baud)
{
	unsigned char n = 0;
	int   N = CPU_FREQUENCY / (32 * baud);

	while(N>=256) {	// BRR8bit٤ʤΤǡ256ʾäץꥹ顼.
		n++;N >>= 2;	//ץꥹ顼n ϣ1/4ʬ.
	}
	SMR = (n & 3);	// SCI3.SMR.BYTE ץꥹ顼 n
	BRR = (N - 1);	// SCI3.BRR      ʬ󥿤 1 ʤͤ򥻥å.
}



char 
getDebugChar (void)
{
  char ch;

  while(!(SSR&SCI_RDRF)){
    if(SSR&(SCI_PER|SCI_FER|SCI_OER)){
      ch = SSR;
      ch &= SCI_ERROR_CLEAR;
      SSR = ch;
      return -1;
    }
  }
  ch = RDR;

  return ch;
}

//
//	ʸʤȤ (-1)
//
int getDebugCharAsync(void)
{
  char ch;

  if(!(SSR&SCI_RDRF)){
    if(SSR&(SCI_PER|SCI_FER|SCI_OER)){
      ch = SSR;
      ch &= SCI_ERROR_CLEAR;
      SSR = ch;
    }
    return -1;
  }
  ch = RDR;
  return ch;
}

void
putDebugChar (char ch)
{
  while(!(SSR&SCI_TDRE));
  TDR = ch;
  while(!(SSR&SCI_TEND));
}
